/**
   ESP WiFi Flurbeleuchtung mit 3 x Bewegungssensoren

   (c) Mic-Berlin August 2020 V2
   WEBOberflaeche ist noch nicht fertig. Keine Eingaben zu machen.

   Noch machen:
     
*/

#include <ESP8266WiFi.h>

const int pinBewegungsmelder1 = D7;
const int pinBewegungsmelder2 = D5;
const int pinBewegungsmelder3 = D0;
const int ledaus = D8;
int g_pin = 12;
int g = 0;
int g_low = 0;

int wifizaehler = 0; // kann spaeter wieder raus

const char* ssid = "Forum4me";
const char* password = "If29BMWnB";
// config static IP
IPAddress ip(192, 168, 2, 49);
IPAddress gateway(192, 168, 2, 1);
IPAddress dns(192, 168, 2, 22);
IPAddress subnet(255, 255, 255, 0);



WiFiServer server(80);

void setup() {

  pinMode(pinBewegungsmelder1, INPUT);
  pinMode(pinBewegungsmelder2, INPUT);
  pinMode(pinBewegungsmelder3, INPUT);
  pinMode(g_pin, OUTPUT);
  pinMode(ledaus, OUTPUT);

  pinMode(LED_BUILTIN, OUTPUT); // BlauLED als Output definieren
  //digitalWrite(LED_BUILTIN, HIGH); // Ausschalten

  Serial.begin(57600);
  delay(1);
  WiFi.mode(WIFI_STA);
  WiFi.config(ip, dns, gateway, subnet);
  WiFi.hostname("Lichtleiste-Bewegungsmelder-Flur1");
  WiFiStart();

  Serial.println("SmartHome Flursender mit Bewegungssensoren");
  delay(800);
  Serial.println("Initialisiere ...");
  Serial.println("g_pin = High");
  digitalWrite(g_pin, HIGH); delay(800);
  Serial.println("g_pin = LOW");
  digitalWrite(g_pin, LOW);

}

void loop()  {
  wifizaehler ++; 
  Serial.print("Wifizaehler: "); Serial.println(wifizaehler); 
  if (g >= 1) {
    digitalWrite(ledaus, LOW);
    bewegung();
  }
  else {
    digitalWrite(ledaus, HIGH);
    Serial.println(" Licht einschalten !");
  }
  digitalWrite(LED_BUILTIN, LOW);
  // Anfang - Neu zum Testen ob das Netzwerk nicht wieder Ausfaellt 13.08.2020
  if (wifizaehler == 100) {  // Groesse der Zahl muss angepasst werden  // kann spaeter wieder raus
    WiFiStart(); // kann spaeter wieder raus
  }
  // Ende
  /* Orginal // muss spaeter wieder aktiviert werden, wenn dass andere wieder raus ist
    if (WiFi.status() != WL_CONNECTED) {
    WiFiStart();
    }

  */
  WiFiClient client = server.available();
  if (!client) {
    return;
  }

  Serial.println("Neue Anfrage");
  unsigned long ultimeout = millis() + 250;
  while (!client.available() && (millis() < ultimeout) ) {
    delay(1);
  }
  if (millis() > ultimeout) {
    Serial.println("Client Verbindung Timeout");
    return;
  }

  String sRequest = client.readStringUntil('\r');
  client.flush();
  Serial.println(sRequest);

  if (sRequest.indexOf("favicon") < 0) {
    int g_pos_1 = sRequest.indexOf("weiss=");
    int g_pos_2 = sRequest.indexOf("&", g_pos_1);
    if (g_pos_2 == -1) {
      g_pos_2 = sRequest.indexOf(" ", g_pos_1);
    }
    String g_str = sRequest.substring(g_pos_1 + 6, g_pos_2);
    if (g_str != "") {
      g = map( g_str.toInt() , 0, 255, 0, 1023);
    }
    Serial.print(" Schalte Weiss: ");
    Serial.println(g);
    analogWrite(g_pin, g );
    String sResponse, sHeader;

    sResponse  = "<html><head><title>ESP8266 Flurbeleuchtung mit Bewegungssensor</title></head>";
    sResponse += "<center><h1>ESP8266 WiFi Flurbeleuchtung mit Bewegungssensor</h1></center><br>";
    //sResponse += "Bitte Parameter fuer weiss in die URL eintragen !<br>";
    sResponse += "</body></html>";

    sHeader  = "HTTP/1.1 200 OK\r\n";
    sHeader += "Content-Length: ";
    sHeader += sResponse.length();
    sHeader += "\r\n";
    sHeader += "Content-Type: text/html\r\n";
    sHeader += "Connection: close\r\n";
    sHeader += "\r\n";

    client.print(sHeader);
    client.print(sResponse);
    client.stop();
    Serial.println("Anfrage beendet");

  }
  digitalWrite(LED_BUILTIN, HIGH);

}

void WiFiStart()
{
  Serial.print("Verbindung aufbauen zu: ");
  Serial.println(ssid);
  WiFi.begin(ssid, password);

  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println();
  Serial.println("Verbunden !");
  server.begin();
  Serial.print("Webserver gestartet mit der IP: ");
  Serial.println(WiFi.localIP());
  wifizaehler = 0;
}


void bewegung() {
  //Serial.println("Bewegung");
  int bewegungsstatus1 = digitalRead(pinBewegungsmelder1);
  Serial.print("Bewegung1 = "); Serial.println(bewegungsstatus1);
  int bewegungsstatus2 = digitalRead(pinBewegungsmelder2);
  Serial.print("Bewegung2 = "); Serial.println(bewegungsstatus2);
  int bewegungsstatus3 = digitalRead(pinBewegungsmelder3);
  Serial.print("Bewegung3 = "); Serial.println(bewegungsstatus3);

  if (bewegungsstatus1 == HIGH || bewegungsstatus2 == HIGH || bewegungsstatus3 == HIGH)
  {
    Serial.println("Bewegung erkannt. 20 Sek. Licht");
    //Serial.print("g_pin: "); Serial.println(g_pin);
    //Serial.print("g: "); Serial.println(g);
    analogWrite(g_pin, g);
    delay(20000); 
  }
  else
  {
    Serial.println("Keine Bewegung erkannt");
    //Serial.print("g_pin: "); Serial.println(g_pin);
    //Serial.print("g_low: "); Serial.println(g_low);
    analogWrite(g_pin, g_low);
    delay(100);
  }
}
